edu.wpi.cscore

## Class CameraServerJNI

- java.lang.Object
- - edu.wpi.cscore.CameraServerJNI

-     public class CameraServerJNI
      extends java.lang.Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `CameraServerJNI.LoggerFunction`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CameraServerJNI()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `addListener(java.util.function.Consumer<VideoEvent> listener, int eventMask, boolean immediateNotify)`
    `static int` | `copySink(int sink)`
    `static int` | `copySource(int source)`
    `static int` | `createCvSink(java.lang.String name)`
    `static int` | `createCvSource(java.lang.String name, int pixelFormat, int width, int height, int fps)`
    `static int` | `createHttpCamera(java.lang.String name, java.lang.String url, int kind)`
    `static int` | `createHttpCameraMulti(java.lang.String name, java.lang.String[] urls, int kind)`
    `static int` | `createMjpegServer(java.lang.String name, java.lang.String listenAddress, int port)`
    `static int` | `createSourceProperty(int source, java.lang.String name, int kind, int minimum, int maximum, int step, int defaultValue, int value)`
    `static int` | `createUsbCameraDev(java.lang.String name, int dev)`
    `static int` | `createUsbCameraPath(java.lang.String name, java.lang.String path)`
    `static int[]` | `enumerateSinks()`
    `static int[]` | `enumerateSourceProperties(int source)`
    `static int[]` | `enumerateSources()`
    `static int[]` | `enumerateSourceSinks(int source)`
    `static VideoMode[]` | `enumerateSourceVideoModes(int source)`
    `static UsbCameraInfo[]` | `enumerateUsbCameras()`
    `static void` | `ForceLoad()`
    `static int` | `getCameraBrightness(int source)`
    `static java.lang.String[]` | `getEnumPropertyChoices(int property)`
    `static java.lang.String` | `getHostname()`
    `static int` | `getHttpCameraKind(int source)`
    `static java.lang.String[]` | `getHttpCameraUrls(int source)`
    `static java.lang.String` | `getMjpegServerListenAddress(int sink)`
    `static int` | `getMjpegServerPort(int sink)`
    `static java.lang.String[]` | `getNetworkInterfaces()`
    `static int` | `getProperty(int property)`
    `static int` | `getPropertyDefault(int property)`
    `static int` | `getPropertyKind(int property)`
    `static int` | `getPropertyMax(int property)`
    `static int` | `getPropertyMin(int property)`
    `static java.lang.String` | `getPropertyName(int property)`
    `static int` | `getPropertyStep(int property)`
    `static java.lang.String` | `getSinkDescription(int sink)`
    `static java.lang.String` | `getSinkError(int sink)`
    `static int` | `getSinkKind(int sink)`
    `static java.lang.String` | `getSinkName(int sink)`
    `static int` | `getSinkSource(int sink)`
    `static int` | `getSinkSourceProperty(int sink, java.lang.String name)`
    `static java.lang.String` | `getSourceDescription(int source)`
    `static int` | `getSourceKind(int source)`
    `static long` | `getSourceLastFrameTime(int source)`
    `static java.lang.String` | `getSourceName(int source)`
    `static int` | `getSourceProperty(int source, java.lang.String name)`
    `static VideoMode` | `getSourceVideoMode(int source)`
    `static java.lang.String` | `getStringProperty(int property)`
    `static java.lang.String` | `getUsbCameraPath(int source)`
    `static long` | `grabSinkFrame(int sink, long imageNativeObj)`
    `static long` | `grabSinkFrameTimeout(int sink, long imageNativeObj, double timeout)`
    `static boolean` | `isSourceConnected(int source)`
    `static void` | `notifySourceError(int source, java.lang.String msg)`
    `static void` | `putSourceFrame(int source, long imageNativeObj)`
    `static void` | `releaseSink(int sink)`
    `static void` | `releaseSource(int source)`
    `static void` | `removeListener(int handle)`
    `static void` | `setCameraBrightness(int source, int brightness)`
    `static void` | `setCameraExposureAuto(int source)`
    `static void` | `setCameraExposureHoldCurrent(int source)`
    `static void` | `setCameraExposureManual(int source, int value)`
    `static void` | `setCameraWhiteBalanceAuto(int source)`
    `static void` | `setCameraWhiteBalanceHoldCurrent(int source)`
    `static void` | `setCameraWhiteBalanceManual(int source, int value)`
    `static void` | `setHttpCameraUrls(int source, java.lang.String[] urls)`
    `static void` | `setLogger(CameraServerJNI.LoggerFunction func, int minLevel)`
    `static void` | `setProperty(int property, int value)`
    `static void` | `setSinkDescription(int sink, java.lang.String description)`
    `static void` | `setSinkEnabled(int sink, boolean enabled)`
    `static void` | `setSinkSource(int sink, int source)`
    `static void` | `setSourceConnected(int source, boolean connected)`
    `static void` | `setSourceDescription(int source, java.lang.String description)`
    `static void` | `setSourceEnumPropertyChoices(int source, int property, java.lang.String[] choices)`
    `static boolean` | `setSourceFPS(int source, int fps)`
    `static boolean` | `setSourcePixelFormat(int source, int pixelFormat)`
    `static boolean` | `setSourceResolution(int source, int width, int height)`
    `static boolean` | `setSourceVideoMode(int source, int pixelFormat, int width, int height, int fps)`
    `static void` | `setStringProperty(int property, java.lang.String value)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CameraServerJNI

          public CameraServerJNI()

  - ### Method Detail

    - #### ForceLoad

          public static void ForceLoad()

    - #### getPropertyKind

          public static int getPropertyKind(int property)

    - #### getPropertyName

          public static java.lang.String getPropertyName(int property)

    - #### getProperty

          public static int getProperty(int property)

    - #### setProperty

          public static void setProperty(int property,
                                         int value)

    - #### getPropertyMin

          public static int getPropertyMin(int property)

    - #### getPropertyMax

          public static int getPropertyMax(int property)

    - #### getPropertyStep

          public static int getPropertyStep(int property)

    - #### getPropertyDefault

          public static int getPropertyDefault(int property)

    - #### getStringProperty

          public static java.lang.String getStringProperty(int property)

    - #### setStringProperty

          public static void setStringProperty(int property,
                                               java.lang.String value)

    - #### getEnumPropertyChoices

          public static java.lang.String[] getEnumPropertyChoices(int property)

    - #### createUsbCameraDev

          public static int createUsbCameraDev(java.lang.String name,
                                               int dev)

    - #### createUsbCameraPath

          public static int createUsbCameraPath(java.lang.String name,
                                                java.lang.String path)

    - #### createHttpCamera

          public static int createHttpCamera(java.lang.String name,
                                             java.lang.String url,
                                             int kind)

    - #### createHttpCameraMulti

          public static int createHttpCameraMulti(java.lang.String name,
                                                  java.lang.String[] urls,
                                                  int kind)

    - #### createCvSource

          public static int createCvSource(java.lang.String name,
                                           int pixelFormat,
                                           int width,
                                           int height,
                                           int fps)

    - #### getSourceKind

          public static int getSourceKind(int source)

    - #### getSourceName

          public static java.lang.String getSourceName(int source)

    - #### getSourceDescription

          public static java.lang.String getSourceDescription(int source)

    - #### getSourceLastFrameTime

          public static long getSourceLastFrameTime(int source)

    - #### isSourceConnected

          public static boolean isSourceConnected(int source)

    - #### getSourceProperty

          public static int getSourceProperty(int source,
                                              java.lang.String name)

    - #### enumerateSourceProperties

          public static int[] enumerateSourceProperties(int source)

    - #### getSourceVideoMode

          public static VideoMode getSourceVideoMode(int source)

    - #### setSourceVideoMode

          public static boolean setSourceVideoMode(int source,
                                                   int pixelFormat,
                                                   int width,
                                                   int height,
                                                   int fps)

    - #### setSourcePixelFormat

          public static boolean setSourcePixelFormat(int source,
                                                     int pixelFormat)

    - #### setSourceResolution

          public static boolean setSourceResolution(int source,
                                                    int width,
                                                    int height)

    - #### setSourceFPS

          public static boolean setSourceFPS(int source,
                                             int fps)

    - #### enumerateSourceVideoModes

          public static VideoMode[] enumerateSourceVideoModes(int source)

    - #### enumerateSourceSinks

          public static int[] enumerateSourceSinks(int source)

    - #### copySource

          public static int copySource(int source)

    - #### releaseSource

          public static void releaseSource(int source)

    - #### setCameraBrightness

          public static void setCameraBrightness(int source,
                                                 int brightness)

    - #### getCameraBrightness

          public static int getCameraBrightness(int source)

    - #### setCameraWhiteBalanceAuto

          public static void setCameraWhiteBalanceAuto(int source)

    - #### setCameraWhiteBalanceHoldCurrent

          public static void setCameraWhiteBalanceHoldCurrent(int source)

    - #### setCameraWhiteBalanceManual

          public static void setCameraWhiteBalanceManual(int source,
                                                         int value)

    - #### setCameraExposureAuto

          public static void setCameraExposureAuto(int source)

    - #### setCameraExposureHoldCurrent

          public static void setCameraExposureHoldCurrent(int source)

    - #### setCameraExposureManual

          public static void setCameraExposureManual(int source,
                                                     int value)

    - #### getUsbCameraPath

          public static java.lang.String getUsbCameraPath(int source)

    - #### getHttpCameraKind

          public static int getHttpCameraKind(int source)

    - #### setHttpCameraUrls

          public static void setHttpCameraUrls(int source,
                                               java.lang.String[] urls)

    - #### getHttpCameraUrls

          public static java.lang.String[] getHttpCameraUrls(int source)

    - #### putSourceFrame

          public static void putSourceFrame(int source,
                                            long imageNativeObj)

    - #### notifySourceError

          public static void notifySourceError(int source,
                                               java.lang.String msg)

    - #### setSourceConnected

          public static void setSourceConnected(int source,
                                                boolean connected)

    - #### setSourceDescription

          public static void setSourceDescription(int source,
                                                  java.lang.String description)

    - #### createSourceProperty

          public static int createSourceProperty(int source,
                                                 java.lang.String name,
                                                 int kind,
                                                 int minimum,
                                                 int maximum,
                                                 int step,
                                                 int defaultValue,
                                                 int value)

    - #### setSourceEnumPropertyChoices

          public static void setSourceEnumPropertyChoices(int source,
                                                          int property,
                                                          java.lang.String[] choices)

    - #### createMjpegServer

          public static int createMjpegServer(java.lang.String name,
                                              java.lang.String listenAddress,
                                              int port)

    - #### createCvSink

          public static int createCvSink(java.lang.String name)

    - #### getSinkKind

          public static int getSinkKind(int sink)

    - #### getSinkName

          public static java.lang.String getSinkName(int sink)

    - #### getSinkDescription

          public static java.lang.String getSinkDescription(int sink)

    - #### setSinkSource

          public static void setSinkSource(int sink,
                                           int source)

    - #### getSinkSourceProperty

          public static int getSinkSourceProperty(int sink,
                                                  java.lang.String name)

    - #### getSinkSource

          public static int getSinkSource(int sink)

    - #### copySink

          public static int copySink(int sink)

    - #### releaseSink

          public static void releaseSink(int sink)

    - #### getMjpegServerListenAddress

          public static java.lang.String getMjpegServerListenAddress(int sink)

    - #### getMjpegServerPort

          public static int getMjpegServerPort(int sink)

    - #### setSinkDescription

          public static void setSinkDescription(int sink,
                                                java.lang.String description)

    - #### grabSinkFrame

          public static long grabSinkFrame(int sink,
                                           long imageNativeObj)

    - #### grabSinkFrameTimeout

          public static long grabSinkFrameTimeout(int sink,
                                                  long imageNativeObj,
                                                  double timeout)

    - #### getSinkError

          public static java.lang.String getSinkError(int sink)

    - #### setSinkEnabled

          public static void setSinkEnabled(int sink,
                                            boolean enabled)

    - #### addListener

          public static int addListener(java.util.function.Consumer<VideoEvent> listener,
                                        int eventMask,
                                        boolean immediateNotify)

    - #### removeListener

          public static void removeListener(int handle)

    - #### setLogger

          public static void setLogger(CameraServerJNI.LoggerFunction func,
                                       int minLevel)

    - #### enumerateUsbCameras

          public static UsbCameraInfo[] enumerateUsbCameras()

    - #### enumerateSources

          public static int[] enumerateSources()

    - #### enumerateSinks

          public static int[] enumerateSinks()

    - #### getHostname

          public static java.lang.String getHostname()

    - #### getNetworkInterfaces

          public static java.lang.String[] getNetworkInterfaces()